package com.adamatomic.Mode
{
	import adobe.utils.CustomActions;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.system.System;
	import flash.text.engine.BreakOpportunity;
	import flash.ui.Mouse;
	import org.flixel.*;

	public class MenuState extends FlxState
	{						
		public var score:Number;
		public var scoreLbl:FlxText;
		public var cursor:Array;
		private var _t:Number;


		private var _paddle:FlxSprite;
		private var _ball:FlxSprite;
		private var _blocks:FlxSprite;
		
		private var lives:int;
		private var livesLbl:FlxText;
		private const tickcount:int = 20;
		
		private var level:int;
		private var _leveltick:int;
		// assumes the point is in the bounds
		public function isOccupied(p:FlxPoint):Boolean
		{
			return (_blocks.pixels.getPixel(p.x - _blocks.x, p.y - _blocks.y) >0 );
		}
		
		public function remove(p:FlxPoint):void
		{
			var x:Number = p.x;
			var y:Number = p.y;
			x -= _blocks.x;
			y -= _blocks.y;
			var w:int = Math.pow(2, level);			
			deleteBlock(Math.floor(x / (2 * w)), Math.floor(y / w));
			_blocks.update();
			_blocks.resetHelpers();
			score += Math.pow(2, level);
			scoreLbl.text = "score : " + score.toString();
			_leveltick--;
			if (_leveltick <= 0)
			{
				if (level > 0)
				{
					level--;
					this._ball.createGraphic(Math.pow(2, level), Math.pow(2, level));
					_leveltick = tickcount;
				}
			}
		}
		
		public function deleteBlock(x:int, y:int):void
		{
			var w:int = Math.pow(2, level);
			
			for (var i:int = x * (2*w); i < (x+1) * (2*w); i++)
			{
				for (var j:int = y * w; j < (y + 1) * w; j++)
				{
					_blocks.pixels.setPixel32(i, j, 0);
				}
			}
		}
		
		private var p11:FlxPoint;
		private var p12:FlxPoint;
		private var p13:FlxPoint;
		private var p21:FlxPoint;
		private var p22:FlxPoint;
		private var p23:FlxPoint;
		private var p31:FlxPoint;
		private var p32:FlxPoint;
		private var p33:FlxPoint;
		
		private var updatedonce:Boolean;
		
		override public function create():void
		{
			updatedonce = false;
			Mouse.hide();
		
			_leveltick = tickcount;
			level = 5;
			
			livesLbl = new FlxText(1, 1, 640, "lives : 3");
			livesLbl.size = 16;
			lives = 3;
			this.add(livesLbl);
			
			scoreLbl = new FlxText(0, 0, 639, "score : 0");
			scoreLbl.alignment = "right";
			scoreLbl.size = 16;
			score = 0;
			this.add(scoreLbl);
			
			_paddle = new FlxSprite(640 / 2, 480-20, null);
			_paddle.createGraphic(60, 10, 0xffffffff);
			_paddle.moves = false;
			this.add(_paddle);
			
			_ball = new FlxSprite(640 / 2 - 5, _paddle.y - 200);
			_ball.createGraphic(32, 32, 0xffffffff);
			_ball.moves = false;
			_ball.velocity.x = 0;
			_ball.velocity.y = 5;
			this.add(_ball);
			
			_blocks = new FlxSprite(0, 30);
			_blocks.createGraphic(640, 216, 0xffffffff,true);
			
			p11 = new FlxPoint();
			p12 = new FlxPoint();
			p13 = new FlxPoint();
			p21 = new FlxPoint();
			p22 = new FlxPoint();
			p23 = new FlxPoint();
			p31 = new FlxPoint();
			p32 = new FlxPoint();
			p33 = new FlxPoint();
			
			this.add(_blocks);
			
		}
		
		override public function update():void
		{			
			super.update();

			updatedonce = !updatedonce;
			
			_t += FlxG.elapsed;
			
			var oldpx:Number = _paddle.x;
			_paddle.x = FlxG.mouse.x-30;
			var paddlev:Number = _paddle.x - oldpx;
		//	_paddle.y = FlxG.mouse.y;
		
			var oldx:Number = _ball.x;
			var oldy:Number = _ball.y;
			
			_ball.x += _ball.velocity.x;
			_ball.y += _ball.velocity.y;
			
			if (_ball.overlaps(_paddle))
			{
				_ball.x = oldx;
				_ball.y = _paddle.y - _ball.height;
				_ball.velocity.y = -_ball.velocity.y;
				_ball.velocity.x -= paddlev;
				if (Math.abs(_ball.velocity.y) < 0.2)
				{
					_ball.velocity.y = 5;
				}
			}
				
			if (_ball.x < 0)
			{
				_ball.x = 0;
				_ball.velocity.x = Math.abs(_ball.velocity.x);
			}
			else if (_ball.x + _ball.width > 640)
			{
				_ball.x = 640 - _ball.width;
				_ball.velocity.x = -Math.abs(_ball.velocity.x);
			}
			
			if (_ball.y < 0)
			{
				_ball.y = 0;
				_ball.velocity.y = Math.abs(_ball.velocity.y);
			}
			else if (_ball.y > 480)
			{
				lives--;
				livesLbl.text = "lives : " + lives.toString();
				if (lives < 0)
				{
					FlxG.state = new TitleState;
					return;
				}
				_ball.x = 640 / 2 - 5;
				_ball.y = _paddle.y - 200;
				_ball.velocity.x = 0;
				_ball.velocity.y = 5;
			}
			
			// check intersection with grid
		
			//if (_blocks.overlaps(_ball))
			{		
				p11.x = _ball.x;
				p11.y = _ball.y;
				p12.x = _ball.x + _ball.width / 2
				p12.y =  _ball.y;
				p13.x = _ball.x + _ball.width;
				p13.y =  _ball.y;
				p21.x = _ball.x;
				p21.y =  _ball.y+_ball.width/2;
				p22.x = _ball.x + _ball.width / 2;
				p22.y =  _ball.y+_ball.width/2;
				p23.x = _ball.x + _ball.width;
				p23.y =  _ball.y+_ball.width/2;
				p31.x = _ball.x;
				p31.y =  _ball.y+_ball.width;
				p32.x = _ball.x + _ball.width / 2;
				p32.y =  _ball.y+_ball.width;
				p33.x = _ball.x + _ball.width / 2;
				p33.y =  _ball.y + _ball.width;
				
				var o12:Boolean =  isOccupied(p12);
				var o32:Boolean =  isOccupied(p32);
				var o21:Boolean =  isOccupied(p21);
				var o23:Boolean =  isOccupied(p23);
				var o11:Boolean =  isOccupied(p11);
				var o13:Boolean =  isOccupied(p13);
				var o31:Boolean =  isOccupied(p31);
				var o33:Boolean =  isOccupied(p33);
						
				if (o11)
				{
					remove(p11);
				}
				if (o12)
				{
					remove(p12);
				}
				if (o13)
				{
					remove(p13);
				}
				if (o31)
				{
					remove(p31);
				}
				if (o32)
				{
					remove(p32);
				}
				if (o33)
				{
					remove(p33);
				}
				if (o21)
				{
					remove(p21);
				}
				if (o23)
				{
					remove(p23);
				}
				
				//things above
				if (o11 || o12 || o13)
				{
					_ball.x = 0;
					_ball.y = 0;
					_ball.velocity.y *= -1;
					_ball.x = oldx;
					_ball.y = oldy;
				}
				
				//things below
				if (o31 || o32 || o33)
				{
					_ball.velocity.y *= -1;		
					_ball.x = oldx;
					_ball.y = oldy;			
				}
							
				// things to left
				if (o11 || o21 || o31)
				{
					_ball.velocity.x *= -1;		
					_ball.x = oldx;
					_ball.y = oldy;			
				}			
				
				// things to right
				if (o13 || o23 || o33)
				{
					_ball.velocity.x *= -1;	
					_ball.x = oldx;
					_ball.y = oldy;				
				}
				
			}
			

			//normalize speed
			var speed:Number = Math.sqrt(_ball.velocity.x * _ball.velocity.x);
			if (speed > 5)
			{
				_ball.velocity.x *= (5 / speed);
			}
			
			if (level == 0)
			{
				speed = Math.sqrt(_ball.velocity.x * _ball.velocity.x + _ball.velocity.y * _ball.velocity.y);
				if (speed > 2)
				{
					_ball.velocity.x *= (2 / speed);
					_ball.velocity.y *= (2 / speed);					
				}
				
				if (!updatedonce)
				{
					//update();
				}
			}
		}
		
	}
}

